@ECHO off
SETLOCAL

SET FILE_NAME=%1%

REM ECHO %FILE_NAME%

IF "%FILE_NAME%" == "" (
  ECHO Give the name of a program to build.
  ECHO For example :
  ECHO   build_app rmason.cpp
  GOTO obuild_return
)

SET NAME=%~n1%
IF "%NAME%" == "" (
  ECHO Empty file name.
  GOTO obuild_return
)

REM ECHO %NAME%

CL.exe 1> NUL 2> NUL
IF ERRORLEVEL 1 (
  ECHO CL.exe program not found. You have to setup VisualC++ environment.
  GOTO obuild_return
)

IF EXIST %NAME%.obj DEL %NAME%.obj

FOR /F "usebackq delims=;" %%s IN (`aida-config --incs`) DO SET aida_incs=%%s
FOR /F "usebackq delims=;" %%s IN (`aida-config --libs`) DO SET aida_libs=%%s

SET flags=/nologo /DWIN32 /MD /O2 /W3  /GX /GR 

CL.exe %flags% /c %aida_incs% /Fo%NAME%.obj /Tp%FILE_NAME% 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO obuild_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

LINK.exe /nologo /OPT:NOREF /out:%NAME%.exe %NAME%.obj %aida_libs% 1> link_exe_error
IF ERRORLEVEL 1 TYPE link_exe_error && GOTO obuild_return
IF NOT ERRORLEVEL 1 DEL link_exe_error 

IF EXIST %NAME%.obj DEL %NAME%.obj

:obuild_return
ENDLOCAL
@ECHO on
