
// Geant4 :
#include <G4RunManager.hh>

// Lib :
#include <Lib/Out.h>

// G4LabTemplateOne :
#include <G4LabTemplateOne/Detector.h>
#include <G4LabTemplateOne/Primary.h>
#include <G4LabTemplateOne/PhysicsList.h>
#include <G4LabTemplateOne/RunAction.h>
#include <G4LabTemplateOne/EventAction.h>
#include <G4LabTemplateOne/SteppingAction.h>

//////////////////////////////////////////////////////////////////////////////
int main(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out;

  G4RunManager* runManager = new G4RunManager;

  runManager->SetUserInitialization(new G4LabTemplateOne::Detector);
  runManager->SetUserInitialization(new G4LabTemplateOne::PhysicsList); 
  runManager->SetUserAction(new G4LabTemplateOne::RunAction(out));
  runManager->SetUserAction(new G4LabTemplateOne::PrimaryGeneratorAction);
  runManager->SetUserAction(new G4LabTemplateOne::EventAction);
  runManager->SetUserAction(new G4LabTemplateOne::SteppingAction());
  //runManager->SetUserAction(new G4Lab::TrackingAction);

  //Initialize G4 kernel
  runManager->Initialize();
    
  runManager->BeamOn(3);

  delete runManager;

  return 0;
}
