#ifndef Lib_BaseSocket_h
#define Lib_BaseSocket_h

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class BaseSocket { 
public:
  virtual bool accept() = 0;
  virtual bool connect() = 0;
  virtual void disconnect() = 0;
public:        
  BaseSocket(Slash::Core::IWriter&,int = 0);  
  virtual ~BaseSocket();
public:        
  bool isConnected() const;
  int socket() const;
  bool sendString(const std::string&); 
  bool sendText(const std::vector<std::string>&); 
  bool waitString(std::string&); 
  bool waitText(std::vector<std::string>&); 
protected:        
  void closeSocket();
protected:        
  Slash::Core::IWriter& fPrinter;
  int fVerboseLevel;
  int fSocket;
};

}

#endif

