#ifndef OnX_Main_h
#define OnX_Main_h

#include <vector>
#include <string>

namespace Slash {namespace UI {class IUI;}}
namespace Slash {namespace Core {class IWriter;}}
namespace Slash {namespace Core {class ISession;}}

namespace Lib {class Printer;}
namespace Lib {class Arguments;}

namespace OnX {

class Session;

class Main {
public:
  static std::vector<std::string> defaultKnownOptions();
public:
  // Have default arguments for java SWIG wrapping.
  // Have args at end (else it compells to handle
  //  std::vector<std::string> in wrappers).
  Main(bool create_UI = true,
       bool show_UI = true,
       const std::vector<std::string>& args = std::vector<std::string>(),
       const std::vector<std::string>& opts = std::vector<std::string>());
  virtual ~Main();
public:
  Slash::UI::IUI* createUI(const std::string& driver,
                           const std::string& file,
                           bool);
  bool isValid() const;
  int steer();
  void show();
  Slash::UI::IUI* ui() const;
  Slash::Core::ISession* session() const;
  bool loadInterpreter(const std::string&,bool aQuiet = false) const;
  std::string findDriver(Slash::Core::IWriter&) const;
  bool findFile(Slash::Core::IWriter&,std::string&) const;
  std::vector<std::string> args() const;
private:
  bool fDummy;
  bool fStatus;
  int fVerboseLevel;
  Session* fSession;
  Slash::UI::IUI* fUI;
  std::vector<std::string> fArgs;
  bool fIB;
  std::string fTerm;
};

}

#endif
