#ifndef OnXLab_TreeFactory_h
#define OnXLab_TreeFactory_h

// Inheritance :
#include <BatchLab/Core/TreeFactory.h>

namespace OnXLab {

class TreeFactory : public BatchLab::TreeFactory {
public: //AIDA/ITreeFactory
  virtual AIDA::ITree* create();
  virtual AIDA::ITree* createTree(const std::string& = ""); //AIDA-v3r3p0
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
  virtual AIDA::ITree* createTree(const std::string& storeName,
                                  const std::string& storeType,
                                  int mode = AIDA::ITreeFactory::AUTO,
                                  const std::string & options = "");
  virtual AIDA::ITree* createNamedTree(const std::string& name,
                                       const std::string& storeName,
                                       const std::string& storeType,
                                       int mode = AIDA::ITreeFactory::AUTO,
                                       const std::string& options = "");
#endif
  virtual AIDA::ITree* create(const std::string&,
                              const std::string& = "",
                              bool = false, 
                              bool = false, 
                              const std::string& = "" );
public:
  TreeFactory(Slash::Core::ISession&);
  virtual ~TreeFactory();
private:
  void setUIRelation(AIDA::ITree&);
};

}

#endif
