#
# WARNING : This script must be executed from an OnX GUI 
#  and not directly from a python shell.
#
# It demonstrates a periodic filling and plotting of an histogram.
#


import AIDA

aida = AIDA.createAnalysisFactory()

treeFactory = aida.createTreeFactory()
memoryTree = treeFactory.create()
del treeFactory

# Create some histogram.
# It will be regulary filled by the OnXLab_update_region script.

plotterFactory = aida.createPlotterFactory()
histogramFactory = aida.createHistogramFactory(memoryTree)

# Get current plotter :
plotter = plotterFactory.create('')

plotter.createRegions(1,1,0)
plotter.setTitle('Fill and update')

h_update = histogramFactory.createHistogram1D('gauss','Gauss',100,-5,5)
plotter.currentRegion().plot(h_update)

# Create a "Cyclic". It will execute all the 1000 msec
# the OnXLab_update_region script.

# WARNING : ICyclic is not AIDA
import OnX
session = OnX.session()
ui = session.ui()

cyclic = ui.createCyclic('OnXLab_exa_cyclic',1000,'Python','import OnX;OnX.import_py("$ONXLABROOT/examples/Python","OnXLab_exa_update_region")')

# A cyclic could be changed like in the below :
#   cyclic.setDelay(1000)
#   cyclic.setScript(1000,'Python','sys_import("OnXLab_update_region")')

# Start the cyclic.
cyclic.start()

# Do not delete h_update (used in OnXLab_exa_update_region.py).

del cyclic
del plotter
del plotterFactory
del histogramFactory
del aida
